----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:50:17 03/12/2010 
-- Design Name: 
-- Module Name:    antibounce - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity antibounce is
	generic (
		clkfrq : integer := 200; -- clkfrq in Mhz
		deadtime : integer := 10 -- dead time in ms
		);
	Port (
		i 		: in std_logic;
		o 		: out std_logic;
		clk 	: in std_logic
		);
end antibounce;

architecture antibounce of antibounce is
	constant count_max : integer := clkfrq * deadtime * 1000;
	
	signal status : std_logic := '0';

begin

	process (clk)
		variable count_v : integer range count_max downto 0 := 0;
	begin
		if rising_edge(clk) then
			if count_v > 0 then
				count_v := count_v-1;
			elsif I /= status then
				status <= I;
				count_v := count_max;
			end if;
		end if;
	end process;
	
	O <= status;

end antibounce;

