----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:37:08 07/13/2012 
-- Design Name: 
-- Module Name:    serializer - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

library WORK;
use WORK.common.ALL;



entity serializer is
    Port (
		input 		: in t_serializer_i;
		output 		: out t_serializer_o;
		clk40 		: in std_logic;
		reset			: in std_logic
	 );
end serializer;

architecture Behavioral of serializer is
	signal i	: t_serializer_i;
	signal o : t_serializer_o := t_serializer_o_init;

	signal datain_osd : std_logic_vector(4 downto 1);
	signal dataout_osd : std_logic;
	signal dataout_dly : std_logic;

	signal s20 : std_logic := '0';
	
	signal DLY_CAL    : std_logic := '0';
	signal DLY_RST    : std_logic := '0';
	signal DLY_BUSY	: std_logic := '0';

begin
	i <= input;
	output <= o;

	o.debug(1)  <= '0';
	o.debug(2)  <= DLY_BUSY;
	o.debug(3)  <= '0';
	o.debug(4)  <= DLY_CAL;
	o.debug(5)  <= '0';
	o.debug(6)  <= DLY_RST;
	o.debug(7)  <= '0';
	o.debug(8)  <= '0';
	o.debug(9)  <= '0';
	o.debug(10) <= '0';
	o.debug(11) <= '0';
	o.debug(12) <= '0';
	o.debug(13) <= '0';
	o.debug(14) <= '0';
	o.debug(15) <= '0';
	o.debug(16) <= '0';
	o.debug(17) <= '0';
	o.debug(18) <= '0';
--	o.debug(19) <= reset;
--	o.debug(20) <= clk40;

	process(clk40)
	begin
		if rising_edge(clk40) then
			s20 <= not s20;
		end if;	
	end process;

	process (i.clk200)
		variable s20_old : std_logic := '0';
		variable subword : integer range 4 downto 0 := 0;
	begin
		if rising_edge(i.clk200) then
			if s20_old /= s20 then
				subword := 4;
			end if;
			s20_old := s20;
			
			for ind in 3 downto 0 loop
				datain_osd(4-ind) <= i.word(subword*4+ind);
			end loop;
			
			subword := subword - 1;
		end if;
	end process;
	

   OSERDES2_inst : OSERDES2
   generic map (
      BYPASS_GCLK_FF => FALSE,       -- Bypass CLKDIV syncronization registers (TRUE/FALSE)
      DATA_RATE_OQ => "SDR",         -- Output Data Rate ("SDR" or "DDR")
      DATA_RATE_OT => "SDR",         -- 3-state Data Rate ("SDR" or "DDR")
      DATA_WIDTH => 4,               -- Parallel data width (2-8)
      OUTPUT_MODE => "SINGLE_ENDED", -- "SINGLE_ENDED" or "DIFFERENTIAL" 
      SERDES_MODE => "NONE",         -- "NONE", "MASTER" or "SLAVE" 
      TRAIN_PATTERN => 0             -- Training Pattern (0-15)
   )
   port map (
      OQ => dataout_osd,               -- 1-bit output: Data output to pad or IODELAY2
      SHIFTOUT1 => open, -- 1-bit output: Cascade data output
      SHIFTOUT2 => open, -- 1-bit output: Cascade 3-state output
      SHIFTOUT3 => open, -- 1-bit output: Cascade differential data output
      SHIFTOUT4 => open, -- 1-bit output: Cascade differential 3-state output
      TQ => open,               -- 1-bit output: 3-state output to pad or IODELAY2
      CLK0 => i.clk800,           -- 1-bit input: I/O clock input
      CLK1 => '0',           -- 1-bit input: Secondary I/O clock input
      CLKDIV => i.clk200,       -- 1-bit input: Logic domain clock input
      -- D1 - D4: 1-bit (each) input: Parallel data inputs
      D1 => datain_osd(1),
      D2 => datain_osd(2),
      D3 => datain_osd(3),
      D4 => datain_osd(4),
      IOCE => i.serdesstrobe,           -- 1-bit input: Data strobe input
      OCE => '1',             -- 1-bit input: Clock enable input
      RST => reset,             -- 1-bit input: Asynchrnous reset input
      SHIFTIN1 => '0',   -- 1-bit input: Cascade data input
      SHIFTIN2 => '0',   -- 1-bit input: Cascade 3-state input
      SHIFTIN3 => '0',   -- 1-bit input: Cascade differential data input
      SHIFTIN4 => '0',   -- 1-bit input: Cascade differential 3-state input
      -- T1 - T4: 1-bit (each) input: 3-state control inputs
      T1 => '0',
      T2 => '0',
      T3 => '0',
      T4 => '0',
      TCE => '1',             -- 1-bit input: 3-state clock enable input
      TRAIN => '0'          -- 1-bit input: Training pattern enable input
   );
	
	o.serialout <= dataout_osd;
end Behavioral;
